<copyright> TESLA mu.Assignment extensions.
    Written by <a href="mailto:tiggr@gerbil.org">Pieter J. Schoenmakers</a>

    Copyright &copy; 1998 Pieter J. Schoenmakers.

    This file is part of TESLA.  TESLA is distributed under the terms of
    the GNU General Public License, a copy of which can be found in the
    TESLA distribution; see the file COPYING.

    <id>$Id: Assignment.t,v 1.7 1998/05/28 15:52:55 tiggr Exp $</id>
    </copyright>

implementation class
Assignment extension tesla: tesla

end;

implementation instance
Assignment extension tesla

void
  coarseUsage int f
       parent Compound c
	 body MethodBody m
{
  [super coarseUsage f parent c body m];
  [lhs coarseUsage f | EXPR_LHS parent c body m];
  [rhs coarseUsage f | EXPR_RHS parent c body m];
}

Cexpr
  precompile Cblock parent
      method Cblock body
{
  if (lhs == void_expr)
    = [rhs precompile parent method body];
  else
    = [rhs precompile parent method body assignmentTo lhs];
}

<doc> Resolve the type of the {lhs} and {rhs}, assume the {type} of the
    {lhs}, and pass to {super}.  </doc>
(Expression, Cons) (resolved, possible_types)
  resolve (Cons, Type) (expected, convertible)
  context Meta context_type
  nested: (MutableIntArray, int) (indices, index)
{
  if (!type)
    {
      Expression e = [lhs replacementForAssignmentBy self];
      if (e != lhs)
	return [e resolve (expected, convertible) context context_type
		  nested: (indices, index)];

      lhs = [lhs resolve (expected, convertible) context context_type
		 nested: (indices, index)];
      type = [[lhs force_type] actualSelf context_type];
      rhs = [rhs resolve (type == error_type ? (expected, convertible)
			  : ([Cons with (type, nil)], nil))
		 context context_type nested: (nil, -1)];
    }
  = [super resolve (expected, convertible) context context_type
	   nested: (indices, index)];
}

end;

implementation class
ReturnAssignment extension tesla

end;

implementation instance
ReturnAssignment extension tesla

void
  coarseUsage int f
       parent Compound c
	 body MethodBody m
{
  [super coarseUsage f parent c body m];
  if (ra_flags & RA_WITH_JUMP != 0)
    {
      if (f & EXPR_BIND != 0 || f & EXPR_UNWIND != 0)
	[[[ParseTom error self] print "RETURN not allowed in unwind/bind"] nl];
      [m set_uses_return TRUE];
    }
}

Cexpr
  precompile Cblock parent
      method Cblock body
{
  = [super precompile parent method body];
  if (ra_flags & RA_WITH_JUMP != 0)
    [parent add [[Cstmt alloc self] init "goto _end_of_method"]];
}

end;
